# Hey emacs this is -*- fundamental -*- 
#
# This is a generic Makefile for mdb
#
CFLAGS=-O -DDEBUG -DNOT_STANDALONE $(XCFLAGS) -I$(SRCDIR)

OBJ68K=mdb.o mdbexp.o dis68.o core.o sym68.o

SRCDIR=/usr/src/1.6.25

default: 
	@echo Please choose target:
	@echo "	make ackack  mdb for 68k with ack compiler"
	@echo "	make ackgnu  mdb for 68k with gnu compiler ack a.out"
	@echo "	make gnugnu  mdb for 68k with gnu compiler gnu a.out"
	@echo " You can specify the top of the minix source tree "
	@echo "   with SRCDIR=/usr/src/ on the command line   "

ackack:
	make mdb CC="cc -D__ACK__ -D_EM_WSIZE=2 -D_MINIX"

ackgnu:
	make mdb CC="gcc -Wall -mshort -D_MINIX" LIBS=-lack

gnugnu:
	make mdb CC="gcc -Wall -mshort -D_MINIX" LIBS=-lbsd XCFLAGS=-DGNU_SYMBOL

#
# Dependencies generated by gcc -MM
#
core.o : core.c mdb.h $(SRCDIR)/kernel/const.h $(SRCDIR)/kernel/type.h \
	 $(SRCDIR)/kernel/proc.h 
dis68.o : dis68.c mdb.h $(SRCDIR)/kernel/const.h $(SRCDIR)/kernel/type.h \
         $(SRCDIR)/kernel/proc.h 
mdb.o : mdb.c mdb.h $(SRCDIR)/kernel/const.h $(SRCDIR)/kernel/type.h \
	 $(SRCDIR)/kernel/proc.h 
mdbexp.o : mdbexp.c mdb.h $(SRCDIR)/kernel/const.h $(SRCDIR)/kernel/type.h \
	 $(SRCDIR)/kernel/proc.h 
sym68.o : sym68.c mdb.h $(SRCDIR)/kernel/const.h $(SRCDIR)/kernel/type.h \
	$(SRCDIR)/kernel/proc.h 
sym86.o : sym86.c db/sym.c 

mdb: $(OBJ68K)
	$(CC) -o $@ $(OBJ68K) $(LIBS)

clean:
	rm -f *.o core mdb a.out *~

dist:
	tar zcvf mdb.tar.Z  \
 	Makefile \
 	a.out.gnu.h \
 	a.out.minix.h \
 	core.c \
 	dis68.c \
 	mdb.1 \
 	mdb.c \
 	mdb.h \
 	mdbexp.c \
 	sym68.c \
 	sym86.c \
 	user.h
	uue -200 mdb.tar.Z

