# Set O=o for ANSI compiler and 68000 K&R compiler, or O=s for PC K&R compiler.
O=o
#O=s

#Set b=/usr for /usr/include or b=<null string> for /include.
b=/usr
#b=

# Directories
i=$b/include
s=$i/sys
h=$i/minix
l=$b/lib

# Programs, flags, and libraries
CC=exec cc
LD=$l/ld
CV=$l/cv

# Set compiler flags.
CFLAGS = -I$i -O

# Set LDFLAGS to -i for PC or -c for 68000.
#LDFLAGS =  -i
LDFLAGS =  -c

HEAD=$l/head.$O
LIB=$l/libc.a $l/end.o

a=fs.h $h/config.h $s/types.h $h/const.h $h/type.h \
  $i/limits.h $i/errno.h \
  $i/ansi.h $h/syslib.h \
  const.h type.h proto.h glo.h $s/dir.h

OBJ =	main.$O open.$O read.$O write.$O pipe.$O \
	device.$O path.$O mount.$O link.$O super.$O inode.$O cache.$O \
	filedes.$O stadir.$O protect.$O time.$O misc.$O utility.$O table.$O \
	putk.$O

fs:	Makefile $(HEAD) $(OBJ) $(LIB)
	$(LD) -o tmp $(LDFLAGS) $(HEAD) $(OBJ) $(LIB)
	$(CV) tmp $@
	@rm -f tmp

clean:
	@rm -f *.s *.$O *.bak fs

cache.$O:	$a
cache.$O:	$h/com.h
cache.$O:	$h/boot.h
cache.$O:	buf.h
cache.$O:	file.h
cache.$O:	fproc.h
cache.$O:	super.h

device.$O:	$a
device.$O:	$h/callnr.h
device.$O:	$h/com.h
device.$O:	dev.h
device.$O:	file.h
device.$O:	fproc.h
device.$O:	inode.h
device.$O:	param.h

filedes.$O:	$a
filedes.$O:	file.h
filedes.$O:	fproc.h
filedes.$O:	inode.h

inode.$O:	$a
inode.$O:	$h/boot.h
inode.$O:	buf.h
inode.$O:	file.h
inode.$O:	fproc.h
inode.$O:	inode.h
inode.$O:	super.h

link.$O:	$a
link.$O:	$s/stat.h
link.$O:	$i/string.h
link.$O:	$h/callnr.h
link.$O:	buf.h
link.$O:	file.h
link.$O:	fproc.h
link.$O:	inode.h
link.$O:	param.h
link.$O:	super.h

main.$O:	$a
main.$O:	$i/fcntl.h
main.$O:	$i/string.h
main.$O:	$h/callnr.h
main.$O:	$h/com.h
main.$O:	$h/boot.h
main.$O:	buf.h
main.$O:	dev.h
main.$O:	file.h
main.$O:	fproc.h
main.$O:	inode.h
main.$O:	param.h
main.$O:	super.h

misc.$O:	$a
misc.$O:	$i/fcntl.h
misc.$O:	$i/tiny-unistd.h
misc.$O:	$h/callnr.h
misc.$O:	$h/com.h
misc.$O:	$h/boot.h
misc.$O:	buf.h
misc.$O:	file.h
misc.$O:	fproc.h
misc.$O:	inode.h
misc.$O:	param.h

mount.$O:	$a
mount.$O:	$h/com.h
mount.$O:	buf.h
mount.$O:	dev.h
mount.$O:	file.h
mount.$O:	fproc.h
mount.$O:	inode.h
mount.$O:	param.h
mount.$O:	super.h

open.$O:	$a
open.$O:	$s/stat.h
open.$O:	$i/fcntl.h
open.$O:	$h/callnr.h
open.$O:	$h/com.h
open.$O:	buf.h
open.$O:	dev.h
open.$O:	file.h
open.$O:	fproc.h
open.$O:	inode.h
open.$O:	param.h

path.$O:	$a
path.$O:	$i/string.h
path.$O:	$h/callnr.h
path.$O:	buf.h
path.$O:	file.h
path.$O:	fproc.h
path.$O:	inode.h
path.$O:	super.h

pipe.$O:	$a
pipe.$O:	$i/fcntl.h
pipe.$O:	$i/signal.h
pipe.$O:	$h/boot.h
pipe.$O:	$h/callnr.h
pipe.$O:	$h/com.h
pipe.$O:	dev.h
pipe.$O:	file.h
pipe.$O:	fproc.h
pipe.$O:	inode.h
pipe.$O:	param.h

protect.$O:	$a
protect.$O:	buf.h
protect.$O:	file.h
protect.$O:	fproc.h
protect.$O:	inode.h
protect.$O:	param.h
protect.$O:	super.h

putk.$O:	$a
putk.$O:	$h/com.h

read.$O:	$a
read.$O:	$i/fcntl.h
read.$O:	$h/com.h
read.$O:	buf.h
read.$O:	file.h
read.$O:	fproc.h
read.$O:	inode.h
read.$O:	param.h
read.$O:	super.h

stadir.$O:	$a
stadir.$O:	$s/stat.h
stadir.$O:	file.h
stadir.$O:	fproc.h
stadir.$O:	inode.h
stadir.$O:	param.h

super.$O:	$a
super.$O:	$i/string.h
super.$O:	$h/boot.h
super.$O:	buf.h
super.$O:	inode.h
super.$O:	super.h

table.$O:	$a
table.$O:	$h/callnr.h
table.$O:	$h/com.h
table.$O:	buf.h
table.$O:	dev.h
table.$O:	file.h
table.$O:	fproc.h
table.$O:	inode.h
table.$O:	super.h

time.$O:	$a
time.$O:	$h/callnr.h
time.$O:	$h/com.h
time.$O:	file.h
time.$O:	fproc.h
time.$O:	inode.h
time.$O:	param.h

utility.$O:	$a
utility.$O:	$h/com.h
utility.$O:	$h/boot.h
utility.$O:	buf.h
utility.$O:	file.h
utility.$O:	fproc.h
utility.$O:	inode.h
utility.$O:	param.h

write.$O:	$a
write.$O:	$i/string.h
write.$O:	buf.h
write.$O:	file.h
write.$O:	fproc.h
write.$O:	inode.h
write.$O:	super.h
