# change if you prefer support for another national keyboard version
KEYMAP	= keymap.uk.h

DEFS	= 
CC	= exec cc
CFLAGS	= -O $(DEFS) -I$i


AS	= cc $(DEFS) -c
LD	= /usr/lib/ld
CV	= /usr/lib/cv
l	= /usr/lib
i	= /usr/include

#SCREEN  = screen.o
SCREEN  = 
SOBJ	= mpx.o klib68k.o stdskclks.o rs2.o fpps.o pmmus.o
COBJ	= start.o stmain.o proc.o system.o stshadow.o \
	  tty.o clock.o memory.o stdma.o stfloppy.o stacsi.o stwini.o \
	  stcon.o stkbd.o stvdu.o stfnt.o stprint.o rs232.o \
 	  table.o dmp.o misc.o stdskclk.o $(SCREEN) stscsi.o fpp.o pmmu.o
OBJ	= $(SOBJ) $(COBJ)
MAP	= keymap.ge.h keymap.uk.h keymap.us.h
HDR	= const.h glo.h kernel.h proc.h proto.h \
	  stacia.h staddr.h stdma.h stfdc.h sthdc.h stmfp.h \
	  stram.h stsound.h stvideo.h tty.h type.h stscsi.h
DEP	= $i/errno.h $i/limits.h $i/sgtty.h $i/signal.h \
	  $i/minix/boot.h $i/minix/callnr.h $i/minix/com.h \
	  $i/minix/config.h $i/minix/const.h $i/minix/type.h \
	  $i/sys/types.h keymap.h $(HDR)
ALL	= kernel

all:	$(ALL)

cp cmp:	all

clean:
	rm -f $(OBJ) tmp kernel

clobber:
	rm -f $(ALL) tmp

kernel:	$(OBJ) $l/libc.a $l/end.o
	$(LD) -c -o tmp $(OBJ) $l/libc.a $l/end.o
	$(CV) tmp $@
	rm tmp

mpx.o:	mpx.s
	$(CC) $(CFLAGS) -c mpx.s
klib68k.o:	klib68k.s
	$(CC) $(CFLAGS) -c klib68k.s
stdskclks.o:	stdskclks.s
	$(CC) $(CFLAGS) -c stdskclks.s
rs2.o:		rs2.s
	$(CC) $(CFLAGS) -c rs2.s
fpps.o:		fpps.s
	$(CC) $(CFLAGS) -c fpps.s
pmmus.o:	pmmus.s
	$(CC) $(CFLAGS) -c pmmus.s

# too crude
$(OBJ):	$(DEP)

keymap.h:	$(KEYMAP)
	rm -f $@; cp $? $@
