#include <minix/config.h>
#if (CHIP == M68000) && defined(FPP)

#ifdef ACK
! section definition
	.sect	.text
	.sect	.rom
	.sect	.data
	.sect	.bss
#endif
!
! public labels
!
	.define	__fppsave
	.define __fppsavereg
	.define __fpprestore
	.define __fpprestreg

	.sect	.text
!
! void _fsave(char *p)
! save fpp context
!
__fppsave:
	move.l	4(a7),a0
	.data2	0xf310		! fsave		(a0)
	rts

!
! void _fppsavereg(char *p)
! save fpp register set
!
__fppsavereg:
	move.l	4(a7),a0
	.data2	0xf210
	.data2	0xbc00		! fmovem.l	fpcr/fpsr/fpiar,(a0)
	add.l	#12,a0
	.data2	0xf210
	.data2	0xf0ff		! fmovem.x	fp0-fp7,(a0)
	rts
!
! void _fpprestore(char *p)
! restore fpp context
!
__fpprestore:
	move.l	4(a7),a0
	.data2	0xf350		! frestore	(a0)
	rts

!
! void _fpprestreg(char *p)
! restore fpp register set
!
__fpprestreg:
	move.l	4(a7),a0
	.data2	0xf210
	.data2	0x9c00		! fmovem.l	(a0),fpcr/fpsr/fpiar
	add.l	#12,a0
	.data2	0xf210
	.data2	0xd0ff		! fmovem.x	(a0),fp0-fp7
	rts
#endif
