/*
 * Atari TT hardware:
 * SCC 8530 circuitry
 */

#define	SCC	((struct scc *)AD_SCC)

struct scc {
	_VOLATILE unsigned char	scc1[8];	/* use only the odd bytes */
};

#define	scc_a_control	scc1[1]	
#define	scc_a_data	scc1[3]	
#define	scc_b_control	scc1[5]	
#define	scc_b_data	scc1[7]	

#define SCC_COM_REG	 0	/* Command register. */
#define SCC_INT_MODE	 1	/* Interrupt & data transfer mode. */
#define SCC_INT_VEC	 2	/* Interrupt vector. */
#define SCC_REC_CTRL	 3	/* Receive parameters & control. */
#define SCC_MSC_MOD	 4	/* Miscellaneous parameters & modes. */
#define SCC_TRA_CTRL	 5	/* Transmit parameters & control. */
#define SCC_SYNC1	 6	/* Sync char 1 (BSC) or address field (SDLC). */
#define SCC_SYNC2	 7	/* Sync char 2 (BSC) or flag (SDLC: 0x7E). */
#define SCC_TRA_BUF	 8	/* Transmit (write) buffer. */
#define SCC_INT_CTRL	 9	/* Master interrupt control. */
#define SCC_MSC_CTRL	10	/* Miscellaneous control bits. */
#define SCC_CLK_MOD	11	/* Clock mode control. */
#define SCC_BAUD_LO	12	/* Lo-byte of baud rate generator time constant. */
#define SCC_BAUD_HI	13	/* Hi-byte of baud rate generator time constant. */
#define SCC_MSC_CTRL2	14	/* Miscellaneous control bits. */
#define SCC_EXT_CTRL	15	/* External status/interrupt control. */

#define SCC_BUF_STAT	 0	/* Receive/transmit buffer status & ext. status. */
#define SCC_REC_COND	 1	/* Receive condition status/residue codes. */
#define SCC_INT_B	 2	/* Interrupt vector (modified in B channel). */
#define SCC_INT_PEND	 3	/* Interrupt pending (channel A only). */
#define SCC_REC_BUF	 8	/* Receive (read) buffer. */
#define SCC_CLK_STAT	10	/* Loop/clock status. */
#define SCC_TIME_LO	12	/* Lower byte of time constant. */
#define SCC_TIME_HI	13	/* Upper byte of time constant. */
#define SCC_EXT_STAT	15	/* External status interrupt enable. */

#define A_EXT_INT     0x08	/* Channel A: modem interrupt pending. */
#define A_T_INT	      0x10	/* Channel A: transmit interrupt pending. */
#define A_R_INT	      0x20	/* Channel A: receive interrupt pending. */
#define B_EXT_INT     0x01	/* Channel B: modem interrupt pending. */
#define B_T_INT	      0x02	/* Channel B: transmit interrupt pending. */
#define B_R_INT	      0x04	/* Channel B: receive interrupt pending. */
