/*
 * Atari ST hardware:
 * Access to circuitry for video
 */

#define	VIDEO	((struct video *)AD_VIDEO)

struct video {
    _VOLATILE unsigned char  vdb[64];	/* sparsely filled, both odd and even */
    unsigned short vd_st_rgb[16];	/* RGB for simultaneous ST colors */
    unsigned char  vd_st_res;		/* ST resolution */
    unsigned char  unused;
    unsigned short vd_tt_res;		/* TT resolution */
    unsigned char  vd_ste_hscroll;	/* MEGA STe: hor bitwise scroll */
    unsigned char  unused2[411];
    unsigned short vd_tt_rgb[256];	/* RGB for simultaneous TT colors */
    
};

#define	vd_ramh		vdb[ 1]	/* base address Video RAM, high byte */
#define	vd_ramm		vdb[ 3]	/* base address Video RAM, mid byte */
#define	vd_ptrh		vdb[ 5]	/* scan address Video RAM, high byte */
#define	vd_ptrm		vdb[ 7]	/* scan address Video RAM, mid byte */
#define	vd_ptrl		vdb[ 9]	/* scan address Video RAM, low byte */
#define	vd_sync		vdb[10]	/* synchronization mode */
#define	vd_raml		vdb[13]	/* base address Video RAM, low byte; STe only */
#define	vd_loff		vdb[15] /* base address line offset, MEGA-STe */

/* bits in vd_sync: */
#define	SYNC_EXT	0x01	/* extern sync */
#define	SYNC_50		0x02	/* 50 Hertz (used for color) */

#if (ATARI_TYPE == TT)
/* bits in vd_tt_rgb[]: */
#define	RGB_B		0x000f
#define	RGB_G		0x00f0
#define	RGB_R		0x0f00

/* some values for vd_tt_rgb[]: */
#define	RGB_BLACK	0x0000
#define	RGB_RED		0x0f00
#define	RGB_GREEN	0x00f0
#define	RGB_BLUE	0x000f
#define	RGB_WHITE	0x0fff
#define	RGB_MAGENTA	0x0f0f
#define	RGB_CYAN	0x00ff
#define	RGB_YELLOW	0x0ff0
#define	RGB_LGREY	0x0aaa
#define	RGB_DGREY	0x0555
#else
/* bits in vd_st_rgb[]: */
#define	RGB_B		0x0007
#define	RGB_G		0x0070
#define	RGB_R		0x0700

/* some values for vd_st_rgb[]: */
#define	RGB_BLACK	0x0000
#define	RGB_RED		0x0700
#define	RGB_GREEN	0x0070
#define	RGB_BLUE	0x0007
#define	RGB_WHITE	0x0777
#define	RGB_MAGENTA	0x0707
#define	RGB_CYAN	0x0077
#define	RGB_YELLOW	0x0770
#define	RGB_LGREY	0x0555
#define	RGB_DGREY	0x0222
#endif

/* values for vd_st_res and vd_tt_res: */
#define	ST_RES_LOW	0x00	/* 320x200,   16 colors */
#define	ST_RES_MID	0x01	/* 640x200,    4 colors */
#define	ST_RES_HIGH	0x02	/* 640x400,  monochrome */
#define	TT_RES_LOW	0x07	/* 320x480,  256 colors */
#define	TT_RES_MID	0x04	/* 640x480,   16 colors */
#define	TT_RES_HIGH	0x06	/* 1280x960, monochrome */
