#
! This is the C run-time start-off routine.  It's job is to take the
! arguments as put on the stack by EXEC, and to parse them and set them up the
! way _main expects them.
! It also initializes _environ when this variable isn't defined by the
! programmer.  The detection of whether _environ belong to us is rather
! simplistic.  We simply check for some magic value, but there is no other
! way.

! public labels
	.define	_environ
	.define __penvp
#ifdef __ACK__
	.define	EXIT
	.define	.trpim
	.define	.trppc
#endif	/* __ACK__ */
#ifdef __ACK__
	.sect	.text
	.sect	.rom
	.sect	.data
	.sect	.bss
#endif	/* __ACK__ */
! external references
	.extern	_main
	.extern	_exit
	.extern begtext, begdata
#ifdef __ACK__
	.extern begbss, endtext, enddata, endbss
#endif	/* __ACK__ */

	.sect	.text
begtext:
start:	
	move.l	sp,a0
	move.l	(a0)+,d0	! long due to lib/exec.c and mm/exec.c
	move.l	d0,d1
	add.l	#1,d1
	asl.l	#2,d1		! pointers are four bytes on 68000
	move.l	a0,a1
	add.l	d1,a1
#ifdef __ACK__
	move.l	a1,__penvp
	! Test whether address of environ < address of end.
	! This is done for separate I&D systems.
	! There is no separate I&D for the 68000-MINIX versions (yet),
	! the check is included for safety reasons.
	move.l	#_environ,d1
	cmp.l	#__end,d1
	bcc	1f
	cmp.w	#21331,_environ
	bne	1f
#endif	/* __ACK__ */
	move.l	a1,_environ	! save _penvp in environ
1:
	move.l	a1,-(sp)	! push environ
	move.l	a0,-(sp)	! push argv
	move.w	d0,-(sp)	! push argc
	jsr	_main
	add.l	#10,sp
#ifdef __ACK__
EXIT:
#endif	/* __ACK__ */
	move.w	d0,-(sp)	! push exit status
	jsr	_exit
L0:	bra	L0

	.sect	.data
begdata:
__penvp:
	.data4	0
#ifndef	__ACK__
_environ:
	.data4	0
#endif


#ifdef	__ACK__
.trpim:	.data2	0
.trppc:	.data4	0
	.sect .bss
begbss:
#endif	/* __ACK__ */
