#include <minix/config.h>
#if ( CHIP == M68000 )
/* memcpy.s			Author: Ralf Wenk
 *
 *	void *memcpy(dst, src, size)
 *	_VOIDSTAR dst;
 *	_CONST _VOIDSTAR src;
 *	size_t size;
 *
 * copy bytes
 */
	.sect .text;.sect .rom;.sect .data;.sect .bss


	.define _memcpy

	.sect .text
_memcpy:
	link	a6,#0
	movem.l	d7/a5,-(sp)
	move.l	8(a6),a0	/* get dst */
	move.l	12(a6),a5	/* get src */
	move.w	16(a6),d7	/* get size */
	bls	I1_1		/* size <= 0 ? exit */
I1_3:
	cmp.l	a0,a5
	bhi	I1_6		/* src <= dst ? no */
	move.l	#0,d0		/* tmp = NULL */
	move.w	d7,d2
	sub.w	#1,d2		/* size - 1 */
	move.w	d2,d0		/* (long)(size - 1) */
	move.l	a5,a1
	add.l	d0,a1		/* src + ( size - 1 ) */
	cmp.l	a0,a1
	bcs	I1_6		/* src + ( size -  ) >= dst ? no */
	add.l	d7,a5		/* src += size */
	add.l	d7,a0		/* dst += size */
	tst.w	d7
I1_C:
	bls	I1_1		/* size <= 0 ? */
	move.b	-(a5),-(a0)	/* *(--dst) = *(--src) */
	sub.w	#1,d7		/* --size */
	bra	I1_C
I1_6:
	move.w	a0,d0
	move.w	a5,d2
	or	d2,d0		/* dst | src */
	and	#1,d0
	bne	I1_E		/* both aligned ? no */
	move.w	d7,d2
	lsr.w	#3,d2		/* size / 8 */
	move.w	d2,d1		/* n = size / 8 */
	lsl.w   #3,d2		/* 8 * n */
	sub.w	d2,d7		/* size -= 8 * n */
	tst.w	d1
I1_14:
	bls	I1_E		/* n <= 0 ? yes */
	move.l	(a5)+,(a0)+	/* *((long *)dst)++ = *((long *)src)++ */
	move.l	(a5)+,(a0)+	/* *((long *)dst)++ = *((long *)src)++ */
	sub.w	#1,d1		/* --n */
	bra	I1_14
I1_E:
	tst.w	d7
I1_18:
	bls	I1_1		/* size <= 0 ? yes */
	move.b	(a5)+,(a0)+	/* *dst++ = *src++ */
	sub.w	#1,d7		/* --size */
	bra	I1_18
I1_1:
	move.l	8(a6),d0	/* return dst */
	movem.l	(sp)+,d7/a5
	unlk	a6
	rts
#endif

