#include <minix/config.h>
#if ( CHIP == M68000 )
/* strcmp.s			Author: Ralf Wenk
 *
 *	int  strcmp(s1, s2)
 *	_CONST char *s1;
 *	_CONST char *s2;
 *
 * compare string s1 to s2, returns <0 for <, 0 for ==, >0 for >
 */
	.sect .text;.sect .rom;.sect .data;.sect .bss

	.define _strcmp

	.sect .text
_strcmp:
	link	a6,#0
	move.l	12(a6),a1	/* get s2 */
	move.l	8(a6),a0	/* get s1 */
I1_3:
	move.b	(a1)+,d1	/* *s2++ */
	move.b	(a0)+,d0
	beq	I1_2		/* *s1++ == EOS ? */
	cmp.b	d1,d0
	beq	I1_3		/* *s1 == *s2 ? try next */
	tst.b	d1
	bne	I1_E		/* *s2 != EOS ? yes */
	move.w	#1,d0		/* only *s2 is EOS - return 1 */
	bra	I1_1
I1_2:
	tst.b	d1
	bne	I1_7		/* *s2 != EOS ? yes */
	clr.w	d0		/* boths are EOS - return 0 */
	bra	I1_1
I1_7:
	move.w	#-1,d0		/* only *s1 is EOS - return -1 */
	bra	I1_1
I1_E:
	sub.b	d1,d0		/* return *s1 - *s2 */
	ext.w	d0
I1_1:
	unlk	a6
	rts
#endif

