CFLAGS	= -O -D_MINIX -D_POSIX_SOURCE
CC	= exec cc
SRC1	= build.c boot.s type.s init.c menu.c
SRC2	= outmix.h fakeunix.c getstruc.c putstruc.c

PARTS	= ../kernel/kernel ../mm/mm ../fs/fs init menu
ALL	= minix.img
LD	= /usr/lib/ld
CV	= /usr/lib/cv
l	= /usr/lib
i	= /usr/include


all:	$(ALL)

cp cmp:	all

clean:
	rm -f *.o $(ALL) build boot_?d type_?d minix_?d init menu

build:	build.c outmix.h getstruc.c putstruc.c $i/minix/config.h $i/minix/const.h
	$(CC) $(CFLAGS) -DATARI_ST build.c -o $@
	chmem =100000 $@

minix.img:	build boot_dd $(PARTS)
	./build boot_dd $(PARTS) $@

minix_fd:	build boot_fd $(PARTS)
	./build boot_fd $(PARTS) $@

minix_dd:	build boot_dd $(PARTS)
	./build boot_dd $(PARTS) $@

type_fd type_dd:	type.s
	cp type.s $@.s
	$(CC) $(CFLAGS) -D__ACK__ -D$@ -c $@.s
	$(LD) -c -o $@.out $@.o
	$(CV) =510 $@.out $@.mix
	dd if=$@.s of=$@.tmp bs=1 count=1 seek=512
	{ \
		dd if=$@.mix bs=1 skip=32; \
		dd if=$@.tmp; \
	} | dd obs=1b | dd of=$@ count=1
	rm -f $@.s $@.o $@.out $@.mix $@.tmp

boot_fd boot_dd:	boot.s
	cp boot.s $@.s
	$(CC) $(CFLAGS) -D__ACK__ -D$@ -c $@.s
	$(LD) -s -c -o $@.out $@.o
	$(CV) =510 $@.out $@.mix
	dd if=$@.mix of=$@ bs=1 skip=32
	rm -f $@.s $@.o $@.out $@.mix

init:	init.o $l/head.o $l/libc.A $l/libe.A $l/end.A
	$(LD) -c -o init.out $l/head.o init.o $l/libc.A $l/libe.A $l/end.A
	$(CV) init.out $@
	rm -f init.out

menu:	menu.o $l/head.o $l/libc.A $l/libe.A $l/end.A
	$(LD) -c -o menu.out $l/head.o menu.o $l/libc.A $l/libe.A $l/end.A
	$(CV) menu.out $@
	rm -f menu.out
